/**
query class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to object based pseudo selection queries.
To use all class extensions read the instruction in the flashclass_extension.as file
*/

trace("flashclass extension <query> loaded");

_global.asSelectQuery = function(p_source, p_key, p_operation, p_value) {
	
	var arr = new Array();
	
	EQUALS = function() {return (arguments[0] == arguments[1]) ? true : false;};
	NOTEQUALS = function() {return (arguments[0] != arguments[1]) ? true : false;};
	GREATER = function() {return (arguments[0] > arguments[1]) ? true : false;};
	SMALLER = function() {return (arguments[0] < arguments[1]) ? true : false;};
	LIKE = function() {return (arguments[0].toLowerCase().indexOf(arguments[1].toLowerCase()) > -1) ? true : false;};
	NOTLIKE = function() {return (arguments[0].toLowerCase().indexOf(arguments[1].toLowerCase()) == -1) ? true : false;};
	
	for(var i = 0; i < p_source.length; i++) {	
		
		if([p_operation](p_source[i][p_key], p_value)) arr.push(p_source[i]);
		
	}
	
	return arr;
	
}

_global.asJoinQuery = function(p_joinee, p_joineeKey, p_joiner, p_joinerKey, p_joinerPrefix) {
	
	var arr = new Array();
	
	for(var i = 0; i < p_joinee.length; i++) {
		
		var entry = new Array();
		
		for(var item in p_joinee[i]) {
			
			if(p_joineeKey == item) {
				
				for(var j = 0; j < p_joiner.length; j++) {
					
					if(p_joiner[j][p_joinerKey] == p_joinee[i][p_joineeKey]) {
						
						for(var jtem in p_joiner[j]) {
						
							entry[p_joinerPrefix + "." + jtem] = p_joiner[j][jtem];
							
						}
						
						break;
						
					}
					
				}
				
			}
			
			entry[item] = p_joinee[i][item];
			
		}
		
		arr.push(entry);
		
	}
	
	return arr;
	
}

_global.asRandomQuery = function(p_source, p_amount) {
	
	var arr = new Array();
	var limit = Math.min(p_amount, p_source.length);
	var count = 0;
	
	while(count < limit) {
		
		var index = Math.floor(Math.random() * p_source.length);
		var exists = false;
		
		for(var i = 0; i < arr.length; i++) {
			
			if(arr[i] == p_source[index]) {
				
				exists = true;
				break;
				
			}
			
		}
		
		if(!exists) {

			arr.push(p_source[index]);
			count++;
			
		}

	}
	
	return arr;
	
}
